package org.johnchamberlain.j2meframework.server;

import javax.servlet.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import org.johnchamberlain.j2meframework.DataPacket;

public class MasterServlet extends HttpServlet {
	private String msServerBase = "/johnchamberlain.com";
	private ApplicationHandler apphandlerLiveChess = new ApplicationHandler_LiveChess();
	private ApplicationHandler apphandlerEventAlert = new ApplicationHandler_EventAlert();
	private static final String DATA_PACKET_PARAM = "DP";
    public MasterServlet() {}
	public void init(ServletConfig config) throws ServletException {
		super.init(config);
	}
	public void destroy() {}
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.vHandleRequest(request, response);
	}
	public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.vHandleRequest(request, response);
	}
	public void doPut(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		response.sendError (HttpServletResponse.SC_BAD_REQUEST, "PUT not supported.");
	}
	public long getLastModified(HttpServletRequest request) { return -1; }
	void vHandleRequest(HttpServletRequest request, HttpServletResponse response){
		try {
			String sRequestPath = request.getPathInfo();
			String sDataPacket = request.getParameter(DATA_PACKET_PARAM);
			ApplicationHandler app = getHandlerForURL( sRequestPath );
			DataPacket dpOut = app.dpProcessPacket(sDataPacket);
			response.setContentType("application/octet-stream");
			response.setContentLength(dpOut.length());
			response.getOutputStream().write(dpOut.getBytes());
			response.getOutputStream().flush();
		} catch(Exception ex) {}
	}
	ApplicationHandler getHandlerForURL( String sRequestPath ){
		/* put your URL resolution logic here */
		if( sRequestPath.equals(msServerBase) + "/LiveChess"){
			return apphandlerLiveChess;
		} else
		if( sRequestPath.equals(msServerBase) + "/EventAlert"){
			return apphandlerEventAlert;
		}
		return null;
	}
	Class getDataPacketClass( String sDP ){ return null; }
}

class ApplicationHandler {
	abstract DataPacket dpProcessPacket( DataPacket dpIn );
}

class ApplicationHandler_LiveChess {
	DataPacket dpProcessPacket( String sDataPacket ){
		DataPacket dp = new DataPacket_LiveChess();
		if( dp.zLoad( sDataPacket ) ){
			/* process packet */
		} else return null;
	}
}

class ApplicationHandler_EventAlert {
	DataPacket dpProcessPacket( DataPacket dpIn ){
		DataPacket dp = new DataPacket_EventAlert();
		if( dp.zLoad( sDataPacket ) ){
			/* process packet */
		} else return null;
	}
}
